//////////////////////////////////////////////////////////////////////////
// define domains

domain='burble.com';
cf_domain(domain);

//////////////////////////////////////////////////////////////////////////
// email via gmail, and keybase auth

D_EXTEND(
    domain,

    // MX records
    MX('@', 1, 'aspmx.l.google.com.'),    
    MX('@', 5, 'alt2.aspmx.l.google.com.'),
    MX('@', 5, 'alt1.aspmx.l.google.com.'),
    MX('@', 10, 'aspmx3.googlemail.com.'),
    MX('@', 10, 'aspmx2.googlemail.com.'),

    // SPF and DMARC
    TXT('@', 'v=spf1 include:mxlogin.com include:_spf.google.com ~all'),
    TXT('_dmarc', 'v=DMARC1; p=reject'),
    TXT('google._domainkey', 'v=DKIM1; k=rsa; p=MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCClWMiLTcb8z420zEocWjRmlGwOH/Edpfk1e2T5S4rE12BeGt2dFk3YA4edeiNlc9E2sJSMepKeGx5mI3jOGfM7LPiL56bCPTvNH6JrHDZCvQuWysHxuXemigPo88DHwOT3N+LAlFdaQSP4ByaBomAPDh6hVEJQfhXS1cMH4RkeQIDAQAB'),

    // keybase verification
    TXT('@', 'keybase-site-verification=ONX4nkgR0mO-sRKbQ9druzvm1PC_iAvMq-1P3pCGFA8')
);


//////////////////////////////////////////////////////////////////////////
// services

// CF tunnels
cf_pages_burble_com =      'sites-burble-com.pages.dev.'
cf_pages_dn42_burble_com = 'sites-dn42-burble-com.pages.dev.'
cf_tun_burble_com =   '66e92c32-22af-4a70-9fd6-e94cd399d444.cfargotunnel.com.'
cf_tun_svcs =         '56612ed6-5c0a-4578-8ef8-179043ded4eb.cfargotunnel.com.'
cf_tun_uptime =       'b276fbd1-d19d-45ef-a3f8-e3463410d2b7.cfargotunnel.com.'

D_EXTEND(
    domain,

    // websites
    ALIAS('@',    cf_pages_burble_com,      CF_PROXY_ON),
    CNAME('www',  cf_pages_burble_com,      CF_PROXY_ON),
    CNAME('dn42', cf_pages_dn42_burble_com, CF_PROXY_ON),

    // status from uptime robot
    CNAME('dn42.status', 'stats.uptimerobot.com.'),    

    // DN42 services

    CNAME('explorer',  cf_tun_svcs,        CF_PROXY_ON),
    CNAME('lg',        cf_tun_svcs,        CF_PROXY_ON),
    CNAME('git',       cf_tun_svcs,        CF_PROXY_ON),
    CNAME('paste',     cf_tun_svcs,        CF_PROXY_ON),
    CNAME('wiki',      cf_tun_svcs,        CF_PROXY_ON),
    CNAME('grafana',   cf_tun_svcs,        CF_PROXY_ON),
    CNAME('lounge',    cf_tun_svcs,        CF_PROXY_ON),
    CNAME('wormhole',  cf_tun_burble_com,  CF_PROXY_ON),
    CNAME('uptime',    cf_tun_uptime,      CF_PROXY_ON),

    // fr-rbx1 redirect
    CNAME('fr-rbx1',      'fr-par1.burble.com.'),
    CNAME('dn42-fr-rbx1', 'fr-par1.burble.com.')
);


//////////////////////////////////////////////////////////////////////////
// nodes

// special cases / test servers

D_EXTEND(
    domain,

    //A(   'shell.fr-rbx1', '178.33.134.8'),
    //AAAA('shell.fr-rbx1', '2001:41d0:8:127:216:3eff:feae:51a8'),
    //A(   'shell.ca-bhs2', '66.70.155.200'),    
    AAAA('shell.ca-bhs2', '2607:5300:60:3741:216:3eff:fed7:2ceb'),

    // fr-nte1 aliases
    AAAA('orange.fr-nte1', '2a01:cb05:8fdb:2555:6c14:ecff:feb1:50c5'),
    AAAA('free.fr-nte1',   '2a01:e0a:46a:2785:488a:edff:fe80:c54f')
    
//    A('uk-bri1', '2.222.170.2')
);


// normal nodes

nodes.forEach(function(n) {

    // ipv4
    if (n[1] != 'undefined') {
        D_EXTEND(domain,A(n[0], n[1]));
    }

    // ipv6
    if (n[2] != 'undefined') {
        D_EXTEND(domain,AAAA(n[0], n[2]));        
    }

    // DN42 public node
    if (n[3] == 'true') {
        D_EXTEND(domain,CNAME('dn42-'+n[0], n[0]+'.burble.com.'));
    }

});

//////////////////////////////////////////////////////////////////////////
// end of file

